#!/bin/bash

START=99

start()
{
# Initialise mouseovers.
# Mouseovers should be set, cleared, and reset if necessary, for any SAT requiring
# a popup, on every reload of the page. Mouseouts never need to be changed.

mouseover0=''
mouseover1=''
mouseover2=''
mouseover3=''
mouseover4=''
mouseover5=''
mouseover6=''
mouseover7=''
mouseover8=''
mouseover9=''
mouseover10=''
mouseover11=''
mouseover12=''

#Initialise (clear) all SAT images and links

satlink1=""
satlink2=""
satlink3=""
satlink4=""
satlink5=""
satlink6=""
satlink7=""
satlink8=""
satlink9=""
satlink10=""
satlink11=""
satlink12=""

sat1="/static/img/SAT-Space-Blank.png"
sat2="/static/img/SAT-Space-Blank.png"
sat3="/static/img/SAT-Space-Blank.png"
sat4="/static/img/SAT-Space-Blank.png"
sat5="/static/img/SAT-Space-Blank.png"
sat6="/static/img/SAT-Space-Blank.png"
sat7="/static/img/SAT-Space-Blank.png"
sat8="/static/img/SAT-Space-Blank.png"
sat9="/static/img/SAT-Space-Blank.png"
sat10="/static/img/SAT-Space-Blank.png"
sat11="/static/img/SAT-Space-Blank.png"
sat12="/static/img/SAT-Space-Blank.png"


#Hide all SAT images and links - Visibility should be set to "visible" only if there is a (non-blank) image to display.

satvis1="hidden"
satvis2="hidden"
satvis3="hidden"
satvis4="hidden"
satvis5="hidden"
satvis6="hidden"
satvis7="hidden"
satvis8="hidden"
satvis9="hidden"
satvis10="hidden"
satvis11="hidden"
satvis12="hidden"


# Generate the txt files every 10 seconds
while (true); do 

# Get model type
model=$(cat /var/iot/model.txt)

# Get base network config data
cable=$(ifconfig | grep -c eth0)
wifi=$(ifconfig  | grep -c wlan0)

cell_en=$(uci -q get network.cellular.auto) # Is interface enabled
cell_if=$(ifconfig  | grep -c 3g-cellular) # Is interface present

# Get server type
server_type=$(uci get gateway.general.server_type)

# Get default route
route=$(ip route| grep default | cut -d " " -f 5 | awk 'NR==1')

# Check Internet connectivity
internet="$(cat /var/iot/internet)"

##################################
# SAT Display Data

################
# Setup Centre - System
# Nothing to do

################
# Setup SAT1 - WiFi WAN

# satvis1="visible"
# img1="/static/img/SAT-Int-Wifi"
# satlink1="/cgi-bin/system-wifi.has"
# mouseover1='info-1'

#wifi=$(ifconfig  | grep -c wlan0)
#wifi_wan=$(ip route | grep -c wlan0 )
#wifi_route=$(ip route| grep default | grep wlan0 | cut -d " " -f 5 | awk 'NR==1')
# wifi_wan_disable=$(uci -q get wireless.sta_0.disabled)
#wifi_wan_disable=`uci -q get network.select_wan.type`

# Set up the SAT icon
# if [[ $wifi_wan_disable = "0" ]] ; then   # No WiFiWAN icon reqd if not enabled
  # sat1="/static/img/SAT-Space-Blank.png"
  # mouseover1=""
  # satlink1=""
  # satvis1="hidden"
# elif [ $internet = "1" ] && [[ $wifi_route = "wlan0" ]]; then
  # sat1=$img1"-tick.png"
# elif [[ $wifi_wan -gt "1" ]] && [[ $wifi_route != "wlan0" ]]; then
  # sat1=$img1"-tick-amber.png"
# else
  # sat1=$img1"-cross.png"
# fi

################
# Setup SAT2 - Eth WAN

satvis2="visible"
img2="/static/img/SAT-Int-Cable"
satlink2="/cgi-bin/system-network.has"
mouseover2='info-2'

eth_wan=$(ip route | grep default | grep -c  eth0)

# Set up the SAT icon
if [ $internet = "1" ] && [[ $route = "eth0" ]]; then
  sat2=$img2"-tick.png"
elif [[ $eth_wan = "1" ]] && [[ $route != "eth0" ]] ; then
  sat2=$img2"-tick-amber.png"
else
  sat2=$img2"-cross.png"
fi


################
# Setup SAT3 - IoT Service

#	For all the conditions below:
	satvis3="visible"	
	mouseover3='info-3'

if [ $server_type = "disabled" ]; then
	satlink3="/cgi-bin/lora-lora.has"
	sat3="/static/img/SAT-Disabled.png"

elif [ $server_type = "lorawan" ]; then
	satlink3="/cgi-bin/lorawan.has"
		#status=$(cat /var/iot/status)
		status=$(systemctl status draginofwd | grep running -c)
	if [ $status = "1" ] && [ $internet == "1" ];then
		sat3="/static/img/SAT-LoRaWAN-tick.png"
	else
		sat3="/static/img/SAT-LoRaWAN-cross.png"
	fi
else
	sat3=""
  	satlink3=""
  	mouseover3=""
fi

################
# Setup SAT5 - Cellular WAN

# satlink5="/cgi-bin/system-cellular.has"

# if [ $cell_en = "1" ]; then
  # satvis5="visible"
  # mouseover5='info-5'
# else
	# sat5="/static/img/SAT-Space-Blank.png" # No Cell icon reqd if cell not enabled
  # mouseover5=''
  # satlink5="#"
  # satvis5="hidden"
# fi


# Set up the SAT icon
# if [ $route = "3g-cellular" ] && [ $internet_cell = "1" ]; then
  # sat5="/static/img/SAT-Int-Cell-tick.png"
# elif [ $route = "3g-cellular" ] && [ $internet_cell = "0" ]; then  
  # sat5="/static/img/SAT-Int-Cell-cross-amber.png"
# elif [ $cell_if = "0" ]; then
	# sat5="/static/img/SAT-Int-Cell-cross.png"
# elif [ $cell_if = "1" ] && [ $route != "3g-cellular" ] && [ $internet_cell == "1" ]; then  
  # sat5="/static/img/SAT-Int-Cell-tick-amber.png"
# elif [ $cell_if = "1" ] && [ $route != "3g-cellular" ] && [ $internet_cell == "0" ]; then  
  # sat5="/static/img/SAT-Int-Cell-cross.png"
# fi

################
# Stetup SAT09 - Miner status
	#docker exec miner miner peer book -s > /tmp/miner_book.txt
	#docker exec miner miner peer addr > /tmp/miner_ecc.txt
	#docker ps | grep miner > /tmp/miner_status.txt
	docker exec miner miner status
	if [ "$?" = "0" ]; then
		sat9="/static/img/SAT-miner-tick.png"
	else
		sat9="/static/img/SAT-miner-cross.png"
	fi
mouseover9='info-9'
satvis9="visible"

satlink9="/cgi-bin/miner-config.has"


################
# Setup SAT10 - LoRa Radios

# TBD  Other status indicator for LoRa radio operation

if [ $server_type = "loriot" ]; then
	pscount=$(ps | grep -c loriot_dragino) # Check is process is running
	satlink10="/cgi-bin/loriot.has"
elif [ $server_type = "station" ];then
	pscount=$(ps | grep station | grep -c -v grep) # Check is process is running
	satlink10="/cgi-bin/lorawan-aws.has"
	version10=`station -v`
else
	pscount="$(systemctl status draginofwd | grep -c running)" # Check is process is running
	satlink10="/cgi-bin/lora-lora.has"
fi

if [[ "$pscount" = "1" ]];then
	sat10="/static/img/SAT-LoRa-tick.png"
else
	sat10="/static/img/SAT-LoRa-cross.png"
fi
 
satvis10="visible"

if [ $server_type = "loriot" ]; then
 	mouseover10='info-10c'
elif [ $server_type = "station" ]; then
	mouseover10='info-10d'
elif [ $model = "LG01" ] || [ $model = "LG02" ]; then
 	mouseover10='info-10a'
else
 	mouseover10='info-10b'
fi



################
# Setup SAT11 - WiFi Access Point

mouseover11='info-11'
satlink11="/cgi-bin/system-status.has"
satvis11="visible"

# Check if WiFi channel is displayed to indicate valid operation of AP, with and without WiFi WAN
iw=$(iw dev | grep -A 10 wlan0 | grep -c AP)
if [ $iw = "1" ] || [ $iw = "2" ];then
 	sat11="/static/img/SAT-Wifi-tick.png"
else
 	sat11="/static/img/SAT-Wifi-cross.png"
fi
wifiap=$(uci -q get wireless.ap_0.disabled)
if [ $wifiap = "1" ]; then
	sat11="/static/img/SAT-Wifi-off.png"
fi
#########################

# Create the temporary txt file

cat > /tmp/sat-data.txt << EOF

" ",
$sat1,$mouseover1,$satlink1,$satvis1 ,
$sat2,$mouseover2,$satlink2,$satvis2 ,
$sat3,$mouseover3,$satlink3,$satvis3 ,
$sat4,$mouseover4,$satlink4,$satvis4 ,
$sat5,$mouseover5,$satlink5,$satvis5 ,
$sat6,$mouseover6,$satlink6,$satvis6 ,
$sat7,$mouseover7,$satlink7,$satvis7 ,
$sat8,$mouseover8,$satlink8,$satvis8 ,
$sat9,$mouseover9,$satlink9,$satvis9 ,
$sat10,$mouseover10,$satlink10,$satvis10 ,
$sat11,$mouseover11,$satlink11,$satvis11 ,
$sat12,$mouseover12,$satlink12,$satvis12 

EOF
##################################################

# Data collection for info boxes

################
# Centre Data - System

model0=$model
firmware0=$(cat /etc/dragino-release )
system0=$(cat /etc/os-release | grep _RELEASE | cut -d = -f2)
load0=$(uptime | sed -n 's/average:/&\n/;s/.*\n//p')
ip0=$(uci -q get network.lan.ipaddr)

# Info bar data
system_time=$(date)
uptime_str=$(uptime  | cut -d " " -f4,5 | tr , " ")

# ################
# SAT1 Data - WiFi WAN

# info_title1="WiFi Internet"
# ssid1=$(iw dev | grep -A 6 wlan0 | grep ssid | awk '{print $2}')
# ip1=$(ifconfig wlan0 | grep inet | awk 'NR==1' | awk '{print $2}')
# txb1=$(ifconfig wlan0 | grep TX | awk 'NR==1' | awk '{print $6$7}' | sed 's/.//' | sed 's/.$//')
# rxb1=$(ifconfig wlan0 | grep RX | awk 'NR==1' | awk '{print $6$7}' | sed 's/.//' | sed 's/.$//')
# signal1=$(iw dev wlan0 link | grep signal | awk '{print $1$2$3}')
# noise1=$(iwinfo|grep -A 5 wlan0 | grep Signal: | cut -d " " -f 15-17)
# rate1=$(iw dev wlan0 link | grep bitrate | awk '{print $2$3$4}')

################
# SAT2 Data - Eth WAN

info_title2="Cable Internet"
ip2a=$(ifconfig eth0 | grep "inet" | awk 'NR==1' | awk '{print $2}')
ip2b=$(ifconfig eth0:9|grep "inet addr"|cut -d ":" -f 2|cut -d " " -f 1)
ip2="$ip2a  $ip2b" 
txb2=$(ifconfig eth0 |grep "TX packets"| awk '{print $6$7}' | sed 's/.//' | sed 's/.$//' )
rxb2=$(ifconfig eth0 |grep "RX packets"| awk '{print $6$7}' | sed 's/.//' | sed 's/.$//' )


################
# SAT3 Data - IoT Service

# Get server type
server_type=$(uci get gateway.general.server_type)
# Initialise
process3=" "
status3="0"
server3=" "

	if [ $server_type = "lorawan" ]; then
		info_title3="LoRaWAN Service"
		server3=$(uci get gateway.server1.server_address)  
		lorawan_boot=$(systemctl status draginofwd | grep running -c)
		lorawanstatus_fwd=$(ps -ef | grep -c fwd)

		if [ $lorawanstatus_fwd = "2" ] && [ $lorawan_boot = "1" ];then
			process3="LoRaWAN process fwd <b>Running</b>"
			if [ `sqlite3 /tmp/lgwdb.sqlite "select * from gwdb" | grep lorawan | grep online -c` = "1" ]; then
				status3=Online
			else
				status3=Offiline
			fi
		else  
			process3="LoRaWAN process fwd <b>Not Running</b>"
		fi

	elif [ $server_type = "station" ]; then
		info_title3="AWS-IoT Service"
		server3=`cat /etc/station/cups.uri`
		station_status=$(ps | grep station | grep -c -v grep)
		if [ $station_status = "2" ]; then
			process3="Station is <b>Ruing</b>"
			status3=$(cat /var/iot/status)
		else
			process3="Station is <b>Not Running</b>"
		fi

fi

################
# SAT5 Data - Cellular WAN

# if [ $cell_en = "1" ]; then
	# info_title5="Cellular Internet"

  # ip5=$(ifconfig 3g-cellular|grep "inet addr"|cut -d ":" -f 2|cut -d " " -f 1)
	# txb5=$(ifconfig 3g-cellular |grep "TX bytes"|cut -d " " -f 18-20)
	# rxb5=$(ifconfig 3g-cellular |grep "RX bytes"|cut -d " " -f 13-15)
	
  #  Get cell status and save to file
  # cp /tmp/celltmp.txt /tmp/cell1.txt 
  # killall comgt
  # (comgt -d /dev/ttyModemAT > /tmp/celltmp.txt; ) &
 
  # # Extract data for Info box
  # sim5=$(cat /tmp/cell1.txt|grep SIM)
  # sig=$(cat /tmp/cell1.txt | grep Signal)
  # net5=$(cat /tmp/cell1.txt | grep network: | cut -d : -f 2)
 
  # # Get signal in dBm
  # signal=$(echo $sig | cut -d : -f2 | cut -d , -f1)
  # if [ $signal -ge "2" ] && [ $signal -le "30" ]; then
  	# dbm=$(expr $signal + $signal - "113")
  	# sig5="$sig  $dbm dBm" 
	# else
		# sig5=" $sig"
	# fi

	# # Fast Cell Internet check	
	# fping -q -I 3g-cellular $host1 
	# if [ $? -eq "0" ]; then
  	# internet5="OK"
	# else
		# fping -q -I 3g-cellular $host2
		# if [ $? -eq "0" ]; then
  		# internet5="OK"
		# else
			# internet5="<font size="2" color="red">Fail</font"
		# fi
	# fi
# fi

################
# SAT9 Data - Miner

	info_title9="Miner"
	docker exec miner miner status
	if [ "$?" = "0" ]; then
		status9="Online"
	else
		status9="Offline"
	fi

	uptime9=`docker ps | grep miner | awk -F' ' '{print$7,$8,$9}'`
	version9=`docker exec miner miner versions | awk 'NR==2{print $2}'`
################
# SAT10 Data - LoRa Radios

# Check for LORIOT mode
if [ $server_type = "loriot" ]; then
	info_title10="LORIOT Mode"
	server10="$server3"
elif [ $server_type = "station" ];then
	info_title10="AWS-IoT Core Station"
	server10="$server3"
else
	info_title10="LoRa Radio"
fi

	gwcfg=$(uci get gateway.general.gwcfg)
	subband=$(uci get gateway.general.subband)
	
	band10=$(grep -e \"$gwcfg\" /var/www/cgi-bin/inc/band.inc | cut -d ">" -f 2 | cut -d "<" -f 1)
	
	if [ $gwcfg == "AU" ]; then
		subband10=$(grep -e \"$subband\" /var/www/cgi-bin/inc/subband-au.inc | cut -d ">" -f 2 | cut -d " " -f 1,2,3)
	elif [ $gwcfg == "US" ]; then
		subband10=$(grep -e \"$subband\" /var/www/cgi-bin/inc/subband-us.inc | cut -d ">" -f 2 | cut -d " " -f 1,2,3)
	elif [ $gwcfg == "CUS" ]; then
		band10="Custom"
		subband10=" " 
	else
		subband10=" "
	fi
#fi

################
# SAT11 Data - WiFi Access Point

info_title11="WiFi Access point"
ssid11=$(iw dev | grep ssid | awk '{print $2}')
chan11=$(iwlist wlan0 channel | grep channels | awk '{print $2,$3}')
#mode11=$(iwlist wlan0 info | grep "HW Mode" |cut -d : -f 3)
txb11=$(ifconfig wlan0 |grep "TX packets" | awk '{print $6,$7}')
rxb11=$(ifconfig wlan0 |grep "RX packets" | awk '{print $6,$7}')

#######################################

# Create the temporay txt file

cat > /tmp/popup-data.txt << EOF


<div class="info" id="info-0">
	<table>
		<tr>	  <th colspan="2">System Info</th></tr>
		<tr>	  <td>Version:</td><td>$firmware0</td></tr>
		<tr>	  <td>Model:</td><td>$model0 </td>	</tr>
		<tr>	  <td>Load Avg:</td><td>$load0 </td>	</tr>
		<tr>	  <td>Date:</td><td>$system_time </td>	</tr>
		<tr>	  <td>Uptime:</td><td>$uptime_str </td>	</tr>
	</table>
</div>	

<div class="info" id="info-1">
	<table>
	<tr>	  <th colspan="2">$info_title1 </th>	</tr>
	<tr>	  <td>SSID:</td><td>$ssid1 </td>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip1 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb1 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb1 </td>	</tr>
	<tr>	  <td>Signal:</td><td>$signal1 </td>	</tr>
#	<tr>	  <td>Noise:</td><td>$noise1 </td>	</tr>
	<tr>	  <td>Bit Rate:</td><td>$rate1 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-2">
	<table>
	<tr>	  <th colspan="2">$info_title2 </th>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip2 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb2 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb2 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-3">
	<table>
	<tr>	  <th colspan="2">$info_title3 </th>	</tr>
	<tr>	  <td>Process:</td><td>$process3 </td>	</tr>
	<tr>	  <td>Status:</td><td>$status3 </td>	</tr>
	<tr>	  <td>Server:</td><td>$server3 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-3a">
	<table>
	<tr>	  <th colspan="2">$info_title3 </th>	</tr>
	<tr>	  <td>Process:</td><td>$process3 </td>	</tr>
	<tr>	  <td>Ver:</td><td>$version3 </td>	</tr>
	<tr>	  <td>Server:</td><td>$server3 </td>	</tr>
	</table>
</div>	

<div class="info" id="info-5">
	<table>
	<tr>	  <th colspan="2">$info_title5 </th>	</tr>
	<tr>	  <td>IP Addr:</td><td>$ip5 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb5 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb5 </td>	</tr>
	<tr>	  <td>SIM:</td><td>$sim5 </td>	</tr>
	<tr>	  <td>Network:</td><td>$net5 </td>	</tr>
	<tr>	  <td>Signal:</td><td>$sig5 </td>	</tr>
	<tr>	  <td>Internet:</td><td><b>$internet5</b></td>	</tr>
	</table>
</div>	

<div class="info" id="info-9">
	<table>
	<tr>	  <th colspan="2">$info_title9 </th>	</tr>
	<tr>	  <td>Uptime:</td><td>$uptime9 </td>	</tr>
	<tr>	  <td>Status:</td><td>$status9	</td>	</tr>
	<tr>	  <td>Vesion:</td><td>$version9	</td>	</tr>
	
	</table>
</div>	

<div class="info" id="info-10a">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Rx Freq:</td><td>$rxfreq10 </td>	</tr>
		<tr>	  <td>Tx Freq:</td><td>$txfreq10 </td>	</tr>
		<tr>	  <td>Rx BW / CR / SF:</td><td>$rxbw10 / $rxcr10 / $rxsf10 </td>	</tr>
		<tr>	  <td>Tx BW / CR / SF:</td><td>$txbw10 / $txcr10 / $txsf10 </td>	</tr>
	</table>
	</div>	

<div class="info" id="info-10b">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Freq Band:</td><td>$band10</td>	</tr>
		<tr>	  <td>Sub Band:</td><td>$subband10</td>	</tr>
	</table>
	</div>	

<div class="info" id="info-10c">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Server:</td><td>$server10</td>	</tr>
	</table>
</div>	

<div class="info" id="info-10d">
	<table>
		<tr>	  <th colspan="2">$info_title10 </th>	</tr>
		<tr>	  <td>Version:</td><td>$version10</td>	</tr>
	</table>
</div>

<div class="info" id="info-11">
	<table>
	<tr>	  <th colspan="2">$info_title11 </th>	</tr>
	<tr>	  <td>SSID:</td><td>$ssid11 </td>	</tr>
	<tr>	  <td>Channel:</td><td>$chan11 </td>	</tr>
	<tr>	  <td>Mode:</td><td>$mode11 </td>	</tr>
	<tr>	  <td>TX Bytes:</td><td>$txb11 </td>	</tr>
	<tr>	  <td>RX Bytes:</td><td>$rxb11 </td>	</tr>
	</table>
</div>	

|||$system_time|||$uptime_str

EOF
#####################

sleep 9; \
done &
} >/dev/null 2>&1    # dump unwanted output to avoid filling log

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	*)
esac

exit

