#!/bin/bash
height_r=$(curl -fsS https://api.helium.io/v1/blocks/height)
[[ -z $height_r ]] && exit 1
height_r=${height_r//\{/}
height_r=${height_r//\}/}
height_r=$(echo "$height_r" | awk -F: '{print $3}')

height_l=$(docker exec miner miner info height | awk '{print $2}')

gap=$((${height_r:=1} - ${height_l:=1}))

echo "Height_remote: ${height_r:-1}"
echo "Height_local:  ${height_l:-1}"
echo "GAP:           ${gap:-$height_r}"
